# Sam Audio · Span Separate API

> แยกเสียงจากไฟล์เสียงโดยใช้ช่วงเวลาที่ระบุ พร้อมคำใบ้ข้อความที่เลือกใช้ได้

แทนที่จะใช้ข้อความเพียงอย่างเดียว คุณส่ง `spans` ที่ระบุช่วงเวลาที่เสียงเป้าหมายเกิดขึ้นใน `audio_url` ได้ `prompt` เป็นตัวเลือก แต่ช่วยระบุประเภทเสียง `trim_to_span` สามารถตัดเอาต์พุตให้เหลือช่วงเวลาที่กำหนด และ `use_sound_activity_ranking` อนุญาตให้จัดอันดับใหม่โดยไม่ใช้พรอมต์ ส่งคืนเสียง `target` และ `residual` ในรูปแบบ wav หรือ mp3

- Model id: `sam-audio/span-separate`
- Made by: Meta
- Category: Audio
- Output: json
- Price per 30 seconds of your input audio: from $0.05 / 30 seconds of input audio (cheapest run $0.05 (50 API credits))
- Run: `POST https://api.doitong.com/v1/run/sam-audio/span-separate`
- Quote: `POST https://api.doitong.com/v1/quote/sam-audio/span-separate`
- Docs page: https://doitong.com/th/developers/models/sam-audio/span-separate

## Pricing

Price: **from $0.05 / 30 seconds of input audio** (the lowest tier; the quote prices your exact input). Price per 30 seconds of your input audio: the input files are measured before the run (length, resolution, frame rate). The quote measures the same files and is exactly what the run charges.

The full example input below costs $0.05 = 50 API credits (1 × 30 s input audio × $0.05).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.com/v1/quote/sam-audio/span-separate` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `audio_url` | `audio` | string (audio URL) | yes |  |  | URL ไฟล์เสียงสำหรับประมวลผล |
| `prompt` |  | string \| null | no |  |  | ตัวช่วยระบุเสียงสำหรับแยกเสียงจากช่วงที่กำหนด แนะนำให้ระบุคำอธิบายข้อความของเสียงที่ต้องการแยก แต่ไม่บังคับ |
| `spans` |  | array of object {start, end, include} | yes |  |  | ช่วงเวลาที่มีเสียงเป้าหมายซึ่งต้องการแยก |
| `spans[].start` |  | number | yes |  | ≥ 0 | ไทม์สแตมป์เริ่มต้นของช่วง วัดเป็นวินาที |
| `spans[].end` |  | number | yes |  | ≥ 0 | ไทม์สแตมป์สิ้นสุดของช่วง วัดเป็นวินาที |
| `spans[].include` |  | boolean | no | `true` |  | การรวมเสียงภายในช่วง: True จะรวมเสียงเหล่านั้น ส่วน False จะไม่รวม |
| `reranking_candidates` |  | integer | no | `1` | 1 – 7 | จำนวนตัวเลือกที่ใช้เฉพาะเมื่อมีพรอมต์ข้อความ: ระบบจะสร้างและจัดอันดับตัวเลือกตามจำนวนดังกล่าว การแยกเฉพาะช่วงจะไม่สนใจการตั้งค่านี้ |
| `acceleration` |  | enum (string) | no | `balanced` | `fast`, `balanced`, `quality` | ระดับการเร่งความเร็วที่ใช้กับการประมวลผล |
| `max_chunk_duration` |  | number | no | `60` | 10 – 60 | ขีดจำกัดเสียงต่อรอบ วัดเป็นวินาที ซึ่งเมื่อเกินแล้วการประมวลผลจะใช้ชิ้นส่วนที่ซ้อนทับกันและผสมเข้าด้วยกัน |
| `chunk_overlap` |  | number | no | `5` | 0 – 30 | ความยาวของส่วนที่ซ้อนทับกันระหว่างชิ้นส่วน วัดเป็นวินาที ใช้สำหรับการผสมแบบ crossfade |
| `use_sound_activity_ranking` |  | boolean | no | `false` |  | ตัวเลือกการจัดอันดับกิจกรรมเสียงที่ต้องใช้ reranking_candidates > 1 ซึ่งเปิดใช้การจัดอันดับซ้ำที่มีประสิทธิภาพสำหรับการแยกเฉพาะช่วงโดยไม่มีพรอมต์ข้อความ ระบบจะให้คะแนนตัวเลือกตามความใกล้เคียงระหว่างบริเวณที่ตรวจพบว่าไม่มีเสียงกับช่วงที่ระบุ |
| `trim_to_span` |  | boolean | no | `false` |  | ตัวเลือกความยาวเอาต์พุตระหว่างช่วงที่ระบุเท่านั้นกับเสียงทั้งหมด เมื่อเปิดใช้ ระบบจะตัดให้เหลือช่วงเวลาในช่วงนั้น ส่วน False จะคงความยาวเต็มและแยกเสียงเป้าหมายตลอดทั้งไฟล์ |
| `output_format` |  | enum (string) | no | `wav` | `wav`, `mp3` | รูปแบบของเสียงที่สร้างขึ้น |

File parameters (`audio`) take a public `https://` URL, a `data:` URI up to 10 MB, or the `file_url` of an upload from `POST /files`.

## Example input

Required parameters only:

```json
{
  "audio": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3",
  "spans": [
    {
      "end": 10,
      "include": true,
      "start": 6
    }
  ]
}
```

A fuller example:

```json
{
  "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3",
  "spans": [
    {
      "end": 10,
      "include": true,
      "start": 6
    }
  ]
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.com/v1/run/sam-audio/span-separate?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3",
    "spans": [
      {
        "end": 10,
        "include": true,
        "start": 6
      }
    ]
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.com/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.com/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/sam-audio/span-separate?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3",
    "spans": [
      {
        "end": 10,
        "include": true,
        "start": 6
      }
    ]
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.com/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3",
    "spans": [
        {
            "end": 10,
            "include": True,
            "start": 6,
        },
    ],
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/sam-audio/span-separate", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.com/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "sam-audio/span-separate",
      "input": {
        "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3",
        "spans": [
          {
            "end": 10,
            "include": true,
            "start": 6
          }
        ]
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "sam-audio/span-separate",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 50,
    "usd": "0.05",
    "charged": 50,
    "refunded": 0
  },
  "input": {
    "audio_url": "https://content.doitong.com/audio/showcase/v3/tools/dub_es.mp3",
    "spans": [
      {
        "end": 10,
        "include": true,
        "start": 6
      }
    ]
  },
  "output": {
    "target": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_name": "0-output.jpeg",
      "file_size": 1843200
    },
    "residual": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_name": "0-output.jpeg",
      "file_size": 1843200
    },
    "duration": 5,
    "sample_rate": 48000
  },
  "outputs": [
    {
      "type": "file",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_size": 1843200,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.com/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `target` | object {url, content_type, file_name, file_size} | เสียงเป้าหมายที่แยกออกมาโดยลำพัง |
| `residual` | object {url, content_type, file_name, file_size} | เสียงที่เหลือนอกเหนือจากเสียงเป้าหมาย |
| `duration` | number | ความยาวเอาต์พุตเสียง วัดเป็นวินาที |
| `sample_rate` | integer | ความถี่การสุ่มตัวอย่างในหน่วย Hz สำหรับเสียงเอาต์พุต |

## Related models

- [Sam Audio · Separate](https://doitong.com/developers/models/sam-audio/separate.md) (`sam-audio/separate`): from $0.05 / 30 seconds of input audio
- [Sam Audio · Visual Separate](https://doitong.com/developers/models/sam-audio/visual-separate.md) (`sam-audio/visual-separate`): from $0.05 / 30 seconds of input video
- [MMAudio V2](https://doitong.com/developers/models/mmaudio-v2.md) (`mmaudio-v2`): $0.001 / second
- [Demucs](https://doitong.com/developers/models/demucs.md) (`demucs`): $0.0007 / second of input audio
- [DeepFilterNet 3](https://doitong.com/developers/models/deepfilternet3.md) (`deepfilternet3`): $0.001 / second of input audio
- [ElevenLabs Audio Isolation](https://doitong.com/developers/models/elevenlabs/audio-isolation.md) (`elevenlabs/audio-isolation`): $0.10 / minute of input file
- [Elevenlabs Sound Effects V2](https://doitong.com/developers/models/elevenlabs/sound-effects/v2.md) (`elevenlabs/sound-effects/v2`): $0.002 / second
- [ElevenLabs Voice Changer](https://doitong.com/developers/models/elevenlabs/voice-changer.md) (`elevenlabs/voice-changer`): $0.30 / minute of input audio

## Links

- HTML page: https://doitong.com/developers/models/sam-audio/span-separate
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=sam-audio/span-separate
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.com/v1/models/sam-audio/span-separate
